"""
Public Cvar Libary (addons/eventscripts/_libs/python/pubcvarlib.py)
Version: 1.00
(C) [#OMEGA] - K2

Agreement

By using this file you agree to the following terms:

This file is delivered 'as-is'. 
I will not take resposibilty for any damage resulting of the use or not-use of this file. 

For distribution and usage see:
http://creativecommons.org/licenses/by-sa/3.0/
"""

#
# Eventscripts Imports
#
import gamethread
import es

# ########## #
# Addon Info #
# ########## #

info = es.AddonInfo()
info.name        = "Public Cvar Libary"
info.version     = "1.00.000"
info.author      = "[#OMEGA] - K2"
info.url         = "http://www.german-slaughterhouse.de"
info.description = "Is used to register a public cvar due to es.makepublic not functioning properly."
info.tags        = "pubcvarlib makepublic public cvar lib libary"

#
# Globals
#

cvars = {}
#interval = 240
selfmodule = __import__(__name__)

#
# Public Functions
# 

def Register(var, value=None, description='', default_value=False):
	"""
	Registers a public variable.
	
	var							-> name of the variable
	value (optional)			-> initial value of the variable
	description (optional)		-> description of the variable
	default_value (optional) 	-> if set to true, the variable will revert to the initial value specified, otherwise the current value will be used
	
	Note: If the variable is already registered as public variable, ValueError will be raised
	"""
	if cvars.has_key(var):
		raise ValueError, 'Variable "%s" already exists!' % var
	cvars[var] = {'value': value, 'default': False}
	es.set(var, value, description)
	es.flags('add','notify',var)
	# Initial setting of the version var
	gamethread.delayed(1, es.set, (var,value))
	
def Unregister(var):
	"""
	Unregisters a public variable.
	
	var							-> name of the variable
	
	Note: If the specified variable is not registered as public variable, ValueError will be raised
	"""
	if not cvars.has_key(var):
		raise ValueError, 'Variable "%s" does not exist!' % var
	del cvars[var]
	es.flags('remove','notify',var)
	es.set(var, 'Unloaded')
	
def Exists(var):
	"""
	Returns True of the specified variable exists, False otherwise
	"""
	return cvars.has_key(var)

def GetCvars():
	"""
	Returns a dictionary of cvars (including settings per cvar)
	"""
	return cvars

#
# Private Functions
#	

def __MakePublic():
	for cvar in cvars:
		if cvars[cvar]['default']:
			es.set(cvar, cvars[cvar]['value'])
		else:
			es.set(cvar, es.getString(cvar))

'''
def __Loop():
	__MakePublic()
	gamethread.delayed(interval, '', __Loop) 
'''			

def __es_map_start(ev):
	gamethread.delayed(5,__MakePublic)

es.addons.registerForEvent(selfmodule, 'es_map_start', __es_map_start)

Register('pubcvarlib_ver', info.version, 'Version of pubcvarlib')